//
//  ViewController.swift
//  TextNodeLongPress
//
//  Created by Abdurahim Jauzee on 29/04/2018.
//  Copyright © 2018 Abdurahim Jauzee. All rights reserved.
//

import UIKit
import AsyncDisplayKit

final class ViewController: ASViewController<ASDisplayNode>, ASTextNodeDelegate {
    
    private let textNode = ASTextNode()

    override init(node: ASDisplayNode) {
        super.init(node: node)
        
        node.automaticallyManagesSubnodes = true
        node.backgroundColor = #colorLiteral(red: 0.9411764706, green: 0.9411764706, blue: 0.9411764706, alpha: 1)
        
        let linkAttributeName = "some-attribute"
        let textNode = self.textNode
        textNode.isUserInteractionEnabled = true
        textNode.delegate = self
        textNode.linkAttributeNames = [linkAttributeName]
        textNode.cornerRadius = 10
        textNode.backgroundColor = .white
        
        let text = """
        Tappable ASTextNode
        """
        let attributedText = NSMutableAttributedString(
            string: text,
            attributes: [
                NSAttributedStringKey.font: UIFont.systemFont(ofSize: 16),
                NSAttributedStringKey(linkAttributeName): text
            ])
        textNode.attributedText = attributedText
        
        node.layoutSpecBlock = { node, size in
            return ASCenterLayoutSpec(centeringOptions: .Y, sizingOptions: .minimumY, child: textNode)
        }
    }
    
    required init?(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
    
    func textNode(_ textNode: ASTextNode, tappedLinkAttribute attribute: String, value: Any, at point: CGPoint, textRange: NSRange) {
        print(#function, attribute, value, point, textRange)
    }
    
    func textNode(_ textNode: ASTextNode, longPressedLinkAttribute attribute: String, value: Any, at point: CGPoint, textRange: NSRange) {
        print(#function, attribute, value, point, textRange)
    }
    
}

